#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>

#define BUF_SIZE 1024

void add_cmd_buttons(void (*make_cmd_button)(char *, char *))
{
    char buf[BUF_SIZE], rc_file[BUF_SIZE], *label, *cmd;
    FILE *rc;

    strcpy(rc_file, getenv("HOME"));
    strcat(rc_file, "/.paletterc");

    if (!(rc = fopen(rc_file, "r"))) {
        printf("can't find $HOME/.paletterc; exiting...\n");
        exit(EXIT_FAILURE);
    }

    while (fgets(buf, sizeof buf, rc)) {
        label = strtok(buf, "=");
        cmd = strtok(NULL, "\n");
        make_cmd_button(label, strdup(cmd));
    }

    fclose(rc);
}

void fork_exec(char *cmd)
{
    pid_t pid = fork();

    switch (pid) {
        case 0:
            execlp("/bin/sh", "sh", "-c", cmd, NULL);
            fprintf(stderr, "exec failed, cleaning up child\n");
            exit(1);
        case -1:
            fprintf(stderr, "can't fork\n"); break;
    }
}
